<template>
  <div>
    <h3 class="first-letter-colored is-size-3">
      Scores
    </h3>
    <div class="has-text-right">
      <feather v-for="i in feathersCount" :key="i" />
    </div>
    <b-table
      :data="scores"
      :striped="true"
      :loading="loading"
      :hoverable="true"
      default-sort="v1_score"
      default-sort-direction="desc">

      <b-table-column :label="$t('levels.name')"
                      sortable
                      :custom-sort="sortLevel"
                      centered
                      header-class="is-capitalized"
                      v-slot="props">
        <trophy :type="props.row.level" size="small" />
      </b-table-column>

      <b-table-column field="period_rank"
                      centered
                      label="#"
                      sortable
                      v-slot="props">
        <router-link :to="{ name: 'GamesRanking',
                            params: { id: props.row.game_id,
                                      level: props.row.level } }"
                      class="has-text-weight-bold">
          {{ props.row.period_rank }}
        </router-link>
      </b-table-column>

      <b-table-column field="star"
                      centered
                      v-slot="props">
        <star :type="props.row.star" />
      </b-table-column>

      <b-table-column field="game"
                      :label="$t('ranking.game')"
                      centered
                      v-slot="props">
        <router-link :to="{ name: 'Game',
                            params: { id: props.row.game_id } }"
                      class="has-text-weight-bold has-text-green">
          {{ props.row.name }}
        </router-link>
      </b-table-column>

      <b-table-column field="value"
                      :label="$t('ranking.score')"
                      sortable
                      centered
                      v-slot="props">
        {{ $n(props.row.value) }}
      </b-table-column>

      <b-table-column field="v1_score"
                      :label="$t('ranking.v1')"
                      sortable
                      centered
                      v-slot="props">
        {{ $n(props.row.v1_score) }}
      </b-table-column>

      <template slot="empty">
        <section class="section">
          <div class="content has-text-green has-text-centered">
            <p>
              <b-icon
                  icon="frown"
                  size="is-large">
              </b-icon>
            </p>
            <p>{{ $t('user.didNotPlay') }}</p>
          </div>
        </section>
      </template>
    </b-table>
  </div>
</template>

<script lang="ts">
import { Component, Prop } from 'vue-property-decorator';
import Trophy from '@/components/Trophy.vue';
import { Score } from '../../types/scores';
import Star from '@/components/Star.vue';
import LevelMixin from '@/mixins/level.vue';
import Feather from '@/components/Feather.vue';

@Component({
  components: { Star, Trophy, Feather }
})
export default class UserScores extends LevelMixin {
  @Prop(Boolean) readonly loading: boolean;
  @Prop(Array) readonly scores: Score[];
  @Prop(Number) readonly feathersCount: number;
}
</script>
